/*
  Dark IPSer v.0.4 - Dark Schneider 2002
  Quinto tentativo di scrittura di un patcher ips...
  Stavolta ci sono riuscito perch ho usato il C invece del VB...
  Il programma si limita semplicemente ad applicare la
  patch, creando un file di log.
*/

#include<stdio.h>
#include<stdlib.h>
#include<string.h>

#define MAXLEN  32

//macro per la conversione in MSB

#define BYTE3_TO_UINT(bp) \
     (((unsigned int)(bp)[0] << 16) & 0x00FF0000) | \
     (((unsigned int)(bp)[1] << 8) & 0x0000FF00) | \
     ((unsigned int)(bp)[2] & 0x000000FF)

#define BYTE2_TO_UINT(bp) \
    (((unsigned int)(bp)[0] << 8) & 0xFF00) | \
    ((unsigned int) (bp)[1] & 0x00FF)


int main(void) {

	FILE *ips, *rom, *log;
	char signature[5];
	char ipsname[MAXLEN];
	char romname[MAXLEN];
	char logname[MAXLEN];

	unsigned char address[3];
	unsigned char length[2];
	unsigned int  uilength;
	unsigned int  uiaddr;
	unsigned int  dupbyte;
	unsigned char runcount[2];
	int patches=0;

	printf("\n++ Dark IPSer v.0.4 - Dark Schneider 2002 ++\n");

	while(true) {

		printf("\nNome del file IPS -> ");
		
		scanf("%s",&ipsname);
		
		ips = fopen(ipsname,"rb");
		
		if(ips==NULL) {

			printf("\nImpossibile aprire il file specificato.\n");

			continue;
		}

		//controllo sulla validit della patch

		fgets(signature,6,ips);

		int cmp = strncmp("PATCH",(char *)signature,5);
		
		if(cmp!=0) {

			printf("\nIl file specificato non  una patch IPS valida.\n");

			continue;
		}
		break;
	}
	
	while(true) {
		printf("\nNome del file a cui applicare la patch -> ");

		scanf("%s",&romname);

		rom = fopen(romname,"rb+");

		if(rom==NULL) {

			printf("\nImpossibile aprire il file specificato.\n");

			continue;
		}

		break;
	}
	
	strcpy (logname,romname);

	log = fopen(strcat(logname,".log"),"a");

	fprintf(log,"++ Dark IPSer v.0.4 - Log per il file %s ++\n", romname);

	fprintf(log,"\nOffset:\t\tBytes scritti:\tCodifica:\n");

	//applicazione della patch al file

	do {

		fread(address,sizeof(char),3,ips);
		fread(length,sizeof(char),2,ips);
		
		uilength = BYTE2_TO_UINT(length);
		uiaddr = BYTE3_TO_UINT(address);
		
		//fine del file
		if(strncmp("EOF",(char *)address,3)==0) {

			printf("\nPatch applicata con successo!\n");
			printf("%d patch inserite.\n",patches);
			fprintf(log,"\n\n%d patch inserite.\n",patches);
		
			fclose(ips);
			fclose(rom);
			fclose(log);
			return(0);
		
		}

		fseek(rom,uiaddr,SEEK_SET);

		if(uilength==0) {	//RLE
			
			fread(runcount,sizeof(char),2,ips);

			dupbyte = fgetc(ips);

			int i;

			for(i=0;i<(int)(BYTE2_TO_UINT(runcount));i++) fputc(dupbyte,rom);

			fprintf(log,"\n%d\t\t%d\t\tRLE",uiaddr,i);

		} else {			//Normale
		
			char *tmp = (char *)malloc(uilength*sizeof(char));

			fread(tmp,sizeof(char),uilength,ips);

			fwrite(tmp,sizeof(char),uilength,rom);

			fprintf(log,"\n%d\t\t%d\t\tNormale",uiaddr,uilength);

			free(tmp);
		}

		patches++;

	} while(strcmp("EOF",(char *)length)!=0);

	return(0);
}